from zope import schema
from zope.interface import implements

from plone.autoform import directives as form

from collective.contact.core.schema import ContactList, ContactChoice
from collective.dms.basecontent.dmsdocument import IDmsDocument, DmsDocument

from pfwbged.basecontent import _

from .widget import AjaxChosenFieldWidget


class IPfwbDocument(IDmsDocument):
    original_paper_version = schema.Choice(
            title=_(u'Original Paper Version'),
            required=False,
            vocabulary='collective.dms.basecontent.recipient_groups')
    form.widget(original_paper_version=AjaxChosenFieldWidget)


class IMedicalCertificate(IPfwbDocument):
    """ """

class MedicalCertificate(DmsDocument):
    implements(IMedicalCertificate)


class IPressRelease(IPfwbDocument):
    """ """
    contacts = ContactList(
            title=_(u'Contacts'),
            required=False)

class PressRelease(DmsDocument):
    implements(IPressRelease)


class IMeetingDate(IPfwbDocument):
    """ """
    meeting_date = schema.Date(
            title=_(u'Meeting Date'),
            required=False)


class IAgenda(IMeetingDate):
    """ """

class Agenda(DmsDocument):
    implements(IAgenda)


class IBoardDecision(IMeetingDate):
    """ """


class BoardDecision(DmsDocument):
    implements(IBoardDecision)


class IGreenBoardDecision(IMeetingDate):
    """ """


class GreenBoardDecision(DmsDocument):
    implements(IGreenBoardDecision)


class IInsuranceDocument(IPfwbDocument):
    """ """
    person = ContactChoice(
            title=_(u'Person'),
            required=False)

    company = schema.TextLine(
            title=_(u'Insurance Company'),
            required=False)

    company_reference = schema.TextLine(
            title=_(u'Insurance Company Reference'),
            required=False)

    document_type = schema.Choice(
            title=_(u'Document Type'),
            vocabulary='InsuranceDocumentTypes')


class InsuranceDocument(DmsDocument):
    implements(IInsuranceDocument)


class IInvoice(IPfwbDocument):
    """ """
    invoice_number = schema.TextLine(
            title=_(u'Invoice Number'),
            required=False)


class Invoice(DmsDocument):
    implements(IInvoice)


class INoteForBoard(IPfwbDocument):
    """ """
    internal_reference_no = schema.TextLine(
            title=_(u'Internal Reference Number'),
            required=False)


class NoteForBoard(DmsDocument):
    implements(INoteForBoard)


class IInternalNote(IPfwbDocument):
    internal_reference_no = schema.TextLine(
            title=_(u'Internal Reference Number'),
            required=False)

    sender = ContactChoice(
            title=_(u'Sender'),
            required=False)

    recipients = ContactList(
            title=_(u'Recipients'),
            required=False)

    session = schema.Choice(title=_(u'Session'),
            vocabulary='Sessions', required=False)


class InternalNote(DmsDocument):
    implements(IInternalNote)


class IMinutes(IPfwbDocument):
    reference = schema.TextLine(
            title=_(u'Internal Reference'),
            required=False)

    meeting_people = schema.TextLine(
            title=_(u'Committee or council that met'),
            required=False)

    sender = ContactChoice(
            title=_(u'Sender'),
            required=False)

    recipients = ContactList(
            title=_(u'Recipients'),
            required=False)


class Minutes(DmsDocument):
    implements(IMinutes)


class IBoardMinutes(IPfwbDocument):
    reference = schema.TextLine(
            title=_(u'Internal Reference'),
            required=False)

    meeting_people = schema.TextLine(
            title=_(u'Committee or council that met'),
            required=False)

    sender = ContactChoice(
            title=_(u'Sender'),
            required=False)

    recipients = ContactList(
            title=_(u'Recipients'),
            required=False)

    immediate = schema.Bool(
            title=_(u'Immediate Decision'),
            default=False)


class BoardMinutes(DmsDocument):
    implements(IBoardMinutes)
